﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread;
using GrapeCity.Win.Spread.InputMan.CellType;

namespace Spread_CutomCellType_demo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            //提高GDI+ 效率
            this.SetStyle(ControlStyles.OptimizedDoubleBuffer | ControlStyles.ResizeRedraw | ControlStyles.AllPaintingInWmPaint, true);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.fpSpread1.ActiveSheet.Rows[1].Height = 100;
            this.fpSpread1.ActiveSheet.Rows[3].Height = 100;
            this.fpSpread1.ActiveSheet.Rows[5].Height = 100;
            this.fpSpread1.ActiveSheet.Columns[0].Width = 100;

            //双区域对角线
            DiagonalCellType ct = new DiagonalCellType(DiagonalSubCellType.e2Region);
            this.fpSpread1.ActiveSheet.Cells[1, 0].CellType = ct;            
            ct.SetText("产品", StringAlignment.Far);
            ct.SetText("日期", StringAlignment.Near);            

            //三区域对角线
            ct = new DiagonalCellType(DiagonalSubCellType.e3Region);
            this.fpSpread1.ActiveSheet.Cells[3, 0].CellType = ct;
            ct.SetText("产品");
            ct.SetText("详情", StringAlignment.Center);
            ct.SetText("日期", StringAlignment.Near);
            this.fpSpread1.ActiveSheet.Cells[3, 0].CellPadding = new CellPadding(5);
            this.fpSpread1.ActiveSheet.Cells[3, 0].Font = new Font("宋体", 12);

            ////四区域对角线
            ct = new DiagonalCellType(DiagonalSubCellType.e4Region);
            this.fpSpread1.ActiveSheet.Cells[5, 0].CellType = ct;
            ct.SetText("类别", StringAlignment.Center);
            ct.SetText("产品", StringAlignment.Center);
            ct.SetText("月", StringAlignment.Center);
            ct.SetText("年", StringAlignment.Center, StringFormatFlags.NoWrap);
            ct.LineColor = Color.Blue;
            ct.LineWidth = 2f;
            this.fpSpread1.ActiveSheet.Cells[5, 0].Font = new Font("楷书", 10);
            this.fpSpread1.ActiveSheet.Cells[5, 0].ForeColor = Color.Green;
            this.fpSpread1.ActiveSheet.Cells[5, 0].CellPadding.Top = 5;
        }

    }
}
