﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using FarPoint.Win.Spread;

namespace Spread_CutomCellType_demo
{
    /// <summary>
    /// 双区域对角线
    /// </summary>
    public class SubDiagonalCellType_2Region : SubDiagonalCellTypeBase
    {
        public override void InnerPaintCell(Graphics g, Rectangle r, Appearance appearance, object value, bool isSelected, bool isLocked, float zoomFactor, Pen LinePen)
        {
            //line 1
            g.DrawLine(LinePen, r.X, r.Y, r.X + r.Width, r.Y + r.Height);

            //text 1
            SizeF sf = m_TextList[0].GetSizeF(g, appearance);
            float x = r.X + r.Width/2 - sf.Width - appearance.CellPadding.Left;
            float y = r.Y + appearance.CellPadding.Top;
            RectangleF rr = new RectangleF(x, y, r.Right - x - appearance.CellPadding.Left, sf.Height);
            m_TextList[0].DrawString(g, rr, appearance);

            //text 2
            sf = m_TextList[1].GetSizeF(g, appearance);
            y = r.Y + r.Height - sf.Height - appearance.CellPadding.Bottom;
            x = r.X + appearance.CellPadding.Left;
            float w = sf.Width > r.Width / 2 ? sf.Width : r.Width / 2;
            rr = new RectangleF(x, y,w , sf.Height);
            m_TextList[1].DrawString(g, rr, appearance);
        }

        protected override void ValidateData(int count)
        {
            if (count != 2)
            {
                throw new Exception("must SetText twice");
            }
        }

        public override DiagonalSubCellType DiagonalSubCellType
        {
            get { return DiagonalSubCellType.e2Region; }
        }
    }

}
