﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using FarPoint.Win.Spread;

namespace Spread_CutomCellType_demo
{
    /// <summary>
    /// 三区域对角线
    /// </summary>
    public class SubDiagonalCellType_3Region : SubDiagonalCellTypeBase
    {
        public override void InnerPaintCell(Graphics g, Rectangle r, Appearance appearance, object value, bool isSelected, bool isLocked, float zoomFactor, Pen LinePen)
        {
            //line 1
            g.DrawLine(LinePen, r.X + r.Width / 2, r.Y, r.X + r.Width, r.Y + r.Height);

            //line 2
            g.DrawLine(LinePen, r.X, r.Y + r.Height / 2, r.X + r.Width, r.Y + r.Height);

            //text 1
            SizeF sf = m_TextList[0].GetSizeF(g, appearance);
            float x = r.Right - sf.Width - appearance.CellPadding.Right;
            float y = r.Y + appearance.CellPadding.Top;
            RectangleF rr = new RectangleF(x, y,
                r.Right - x - appearance.CellPadding.Left, sf.Height);
            m_TextList[0].DrawString(g, rr, appearance);

            //text 2
            sf = m_TextList[1].GetSizeF(g, appearance);
            x = r.X + appearance.CellPadding.Left;
            rr = new RectangleF(x, r.Y + r.Height / 3, sf.Width + appearance.CellPadding.Left, sf.Height);
            m_TextList[1].DrawString(g, rr, appearance);

            //text 3
            sf = m_TextList[2].GetSizeF(g, appearance);
            x = r.X + appearance.CellPadding.Bottom;
            y = r.Y + r.Height - sf.Height - appearance.CellPadding.Left;
            rr = new RectangleF(x, y, sf.Width + appearance.CellPadding.Left, sf.Height);
            m_TextList[2].DrawString(g, rr, appearance);
        }

        protected override void ValidateData(int count)
        {
            if (count != 3)
            {
                throw new Exception("must SetText three times");
            }
        }

        public override DiagonalSubCellType DiagonalSubCellType
        {
            get { return DiagonalSubCellType.e3Region; }
        }
    }
}
