﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using FarPoint.Win.Spread;

namespace Spread_CutomCellType_demo
{
    /// <summary>
    /// 四区域对角线
    /// </summary>
    public class SubDiagonalCellType_4Region : SubDiagonalCellTypeBase
    {
        public override void InnerPaintCell(Graphics g, Rectangle r, Appearance appearance, object value, bool isSelected, bool isLocked, float zoomFactor, Pen LinePen)
        {

            //line 1
            g.DrawLine(LinePen, r.X, r.Y, r.X + r.Width, r.Y + r.Height / 2);

            //line 2
            g.DrawLine(LinePen, r.X, r.Y, r.X + r.Width, r.Y + r.Height);

            //line 3
            g.DrawLine(LinePen, r.X, r.Y, r.X + r.Width / 2, r.Y + r.Height);

            //text 1
            SizeF sf = m_TextList[0].GetSizeF(g, appearance);
            float x = r.Right - sf.Width - appearance.CellPadding.Right;
            float y = r.Y + appearance.CellPadding.Top;
            RectangleF rr = new RectangleF(x, y,
                r.Right - x - appearance.CellPadding.Left, sf.Height + appearance.CellPadding.Top);
            m_TextList[0].DrawString(g, rr, appearance);

            //text 2
            sf = m_TextList[1].GetSizeF(g, appearance);
            x = r.X + r.Width - sf.Width - appearance.CellPadding.Right;
            y = r.Y + r.Height / 2 + sf.Height / 3 - appearance.CellPadding.Top;
            rr = new RectangleF(x, y,
                r.Right - x - appearance.CellPadding.Left, sf.Height + appearance.CellPadding.Top);
            m_TextList[1].DrawString(g, rr, appearance);

            ////text 3
             sf = m_TextList[2].GetSizeF(g, appearance);
             x = r.X + r.Width / 2 - appearance.CellPadding.Right;
             y = r.Y + r.Height - sf.Height - appearance.CellPadding.Bottom;
             rr = new RectangleF(x, y,
                 r.Right - x - appearance.CellPadding.Left, sf.Height + appearance.CellPadding.Bottom);
             m_TextList[2].DrawString(g, rr, appearance);

            ////text 4
             sf = m_TextList[3].GetSizeF(g, appearance);
             x = r.X - appearance.CellPadding.Left;
             y = r.Y + r.Height - sf.Height - appearance.CellPadding.Bottom;
             rr = new RectangleF(x, y, r.Width / 2 - appearance.CellPadding.Left, sf.Height + appearance.CellPadding.Bottom);
             m_TextList[3].DrawString(g, rr, appearance);
        }

        protected override void ValidateData(int count)
        {
            if (count != 4)
            {
                throw new Exception("must SetText four times");
            }
        }

        public override DiagonalSubCellType DiagonalSubCellType
        {
            get { return DiagonalSubCellType.e4Region; }
        }
    }
}
