﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using FarPoint.Win.Spread;

namespace Spread_CutomCellType_demo
{
    /// <summary>
    /// 绘制文本包装类
    /// </summary>
    public class TextWrap
    {
        public string Text { get; set; }
        public StringFormatFlags StringFormatFlags { get; set; }
        public StringAlignment StringAlignment { get; set; }

        /// <summary>
        /// 画文字
        /// </summary>
        /// <param name="g">图像画笔</param>
        /// <param name="rr">绘制文字的矩形</param>
        /// <param name="appearance">CellType设置属性集合</param>
        public void DrawString(Graphics g, RectangleF rr, Appearance appearance)
        {
            using (SolidBrush LineBrush = new SolidBrush(appearance.ForeColor))
            {
                using (StringFormat StringFormat = new StringFormat(StringFormatFlags) { Alignment = StringAlignment })
                {
                    g.DrawString(Text, appearance.Font, LineBrush, rr, StringFormat);
                }
            }
        }

        /// <summary>
        /// 获得当前文本的Size
        /// </summary>
        /// <param name="g"></param>
        /// <param name="appearance"></param>
        /// <returns></returns>
        public SizeF GetSizeF(Graphics g, Appearance appearance)
        {
            SizeF sf = g.MeasureString(Text, appearance.Font);
            return sf;
        }
    }

}
